package com.casic.dcms.ui.fragment.threepkg;

import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.casic.dcms.adapter.PackageCaseAdapter;
import com.casic.dcms.base.AndroidxBaseFragment;
import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.bean.PackageOrDeptBean;
import com.casic.dcms.databinding.FragmentPackageCaseBinding;
import com.casic.dcms.mvp.presenter.impl.PackageHandledPresenterImpl;
import com.casic.dcms.mvp.view.IPackageCaseView;
import com.casic.dcms.ui.PackageHandledDetailActivity;
import com.casic.dcms.utils.Constant;
import com.casic.dcms.utils.ToastHelper;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnLoadMoreListener;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;

public class PackageHandledFragment extends AndroidxBaseFragment<FragmentPackageCaseBinding> implements IPackageCaseView {

    private Context context;
    private PackageHandledPresenterImpl handledPresenter;
    private int pageIndex = 1;
    private List<PackageOrDeptBean.DataBean.RowsBean> dataBeans = new ArrayList<>();
    private boolean isRefresh, isLoadMore = false;
    private static WeakReferenceHandler weakReferenceHandler;
    private PackageCaseAdapter adapter;

    @Override
    protected void setupTopBarLayout() {
        context = getContext();
    }

    @Override
    protected void initData() {
        handledPresenter = new PackageHandledPresenterImpl(this);
        handledPresenter.onReadyRetrofitRequest("1", pageIndex);

        weakReferenceHandler = new WeakReferenceHandler(this);
    }

    @Override
    protected void initEvent() {
        viewBinding.refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull final RefreshLayout refreshLayout) {
                isRefresh = true;
                //刷新之后页码重置
                pageIndex = 1;
                handledPresenter.onReadyRetrofitRequest("1", pageIndex);
            }
        });
        viewBinding.refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull final RefreshLayout refreshLayout) {
                isLoadMore = true;
                pageIndex++;
                handledPresenter.onReadyRetrofitRequest("1", pageIndex);
            }
        });
    }

    /**
     * 供{@link com.casic.dcms.ui.PackageTodoDetailActivity#obtainCaseHandleResult(ActionResultBean)}调用
     */
    public static void sendEmptyMessage(int what) {
        if (weakReferenceHandler == null) {
            return;
        }
        weakReferenceHandler.sendEmptyMessage(what);
    }

    private static class WeakReferenceHandler extends Handler {
        private final WeakReference<PackageHandledFragment> reference;

        private WeakReferenceHandler(PackageHandledFragment fragment) {
            reference = new WeakReference<>(fragment);
        }

        @Override
        public void handleMessage(Message msg) {
            PackageHandledFragment handledFragment = reference.get();
            if (msg.what == Constant.PACKAGE_DONE) {
                handledFragment.isRefresh = true;
                //刷新之后页码重置
                handledFragment.pageIndex = 1;
                handledFragment.handledPresenter.onReadyRetrofitRequest("1", handledFragment.pageIndex);
            } else if (msg.what == 2021060301) {
                if (handledFragment.isRefresh || handledFragment.isLoadMore) {
                    handledFragment.adapter.notifyDataSetChanged();
                } else {
                    //首次加载数据
                    if (handledFragment.dataBeans.size() == 0) {
                        handledFragment.viewBinding.emptyView.show("您暂时没有待办案卷", null);
                    } else {
                        handledFragment.viewBinding.emptyView.hide();
                        handledFragment.adapter = new PackageCaseAdapter(handledFragment.context, handledFragment.dataBeans);
                        handledFragment.viewBinding.caseRecyclerView.setLayoutManager(new LinearLayoutManager(handledFragment.context));
                        handledFragment.viewBinding.caseRecyclerView.addItemDecoration(new DividerItemDecoration(handledFragment.context, DividerItemDecoration.VERTICAL));
                        handledFragment.viewBinding.caseRecyclerView.setAdapter(handledFragment.adapter);
                        handledFragment.adapter.setOnItemClickListener(new PackageCaseAdapter.OnItemClickListener() {
                            @Override
                            public void onClick(int position) {
                                Intent intent = new Intent(handledFragment.context, PackageHandledDetailActivity.class);
                                intent.putExtra("id", handledFragment.dataBeans.get(position).getId());
                                handledFragment.startActivity(intent);
                            }
                        });
                    }
                }
            }
        }
    }

    @Override
    public void obtainPackageCaseResult(PackageOrDeptBean resultBean) {
        if (resultBean.isSuccess()) {
            List<PackageOrDeptBean.DataBean.RowsBean> dataRows = resultBean.getData().getRows();
            if (isRefresh) {
                dataBeans.clear();//下拉刷新必须先清空之前的List，不然会出现数据重复的问题
                dataBeans = dataRows;
                viewBinding.refreshLayout.finishRefresh();
                isRefresh = false;
            } else if (isLoadMore) {
                if (dataRows.size() == 0) {
                    ToastHelper.showToast("到底了，别拉了", ToastHelper.INFO);
                }
                dataBeans.addAll(dataRows);
                viewBinding.refreshLayout.finishLoadMore();
                isLoadMore = false;
            } else {
                dataBeans = dataRows;
            }
            weakReferenceHandler.sendEmptyMessage(2021060301);
        }
    }

    @Override
    public void onDestroyView() {
        if (handledPresenter != null) {
            handledPresenter.disposeRetrofitRequest();
        }
        super.onDestroyView();
    }
}
